Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GeneralizedQuadraticAssignmentProblem.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GeneralizedQuadraticAssignmentProblem.cs	(revision 7547)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GeneralizedQuadraticAssignmentProblem.cs	(revision 7548)
@@ -39,9 +39,9 @@
   [StorableClass]
   public sealed class GeneralizedQuadraticAssignmentProblem : SingleObjectiveHeuristicOptimizationProblem<IGQAPEvaluator, IGQAPSolutionCreator>, IStorableContent,
-    IConsumable<QAPInstance>,
-    IConsumable<CTAPInstance>,
-    IConsumable<TSPInstance>,
-    IConsumable<ATSPInstance>,
-    IConsumable<GQAPInstance> {
+    IProblemInstanceConsumer<QAPData>,
+    IProblemInstanceConsumer<CTAPData>,
+    IProblemInstanceConsumer<TSPData>,
+    IProblemInstanceConsumer<ATSPData>,
+    IProblemInstanceConsumer<GQAPData> {
 
     public override Image ItemImage {
@@ -169,5 +169,5 @@
       Parameters.Add(new ValueParameter<DoubleMatrix>("InstallationCosts", InstallationCostsDescription, new DoubleMatrix(), false));
       Parameters.Add(new FixedValueParameter<DoubleValue>("TransportationCosts", TransportationCostsDescription, new DoubleValue(1)));
-      Parameters.Add(new FixedValueParameter<DoubleValue>("OverbookedCapacityPenalty", OverbookedCapacityPenaltyDescription, new DoubleValue(1000)));
+      Parameters.Add(new FixedValueParameter<DoubleValue>("OverbookedCapacityPenalty", OverbookedCapacityPenaltyDescription, new DoubleValue(100000)));
       Parameters.Add(new ValueParameter<DoubleArray>("Demands", DemandsDescription, new DoubleArray(), false));
       Parameters.Add(new ValueParameter<DoubleArray>("Capacities", CapacitiesDescription, new DoubleArray(), false));
@@ -213,161 +213,167 @@
     }
 
-    #region Problem Instance Consumptions
-    public bool LoadFrom(QAPInstance instance) {
-      try {
-        Name = instance.Name;
-        Description = instance.Description;
-
-        Weights = new DoubleMatrix(instance.Weights);
-        Distances = new DoubleMatrix(instance.Distances);
-        InstallationCosts = new DoubleMatrix(Weights.Rows, Distances.Columns); // all zero
-        Capacities = new DoubleArray(Enumerable.Range(0, Distances.Rows).Select(x => 1.0).ToArray());
-        Demands = new DoubleArray(Enumerable.Range(0, Weights.Rows).Select(x => 1.0).ToArray());
-
-        TransportationCosts.Value = 1;
-
-        if (instance.BestKnownAssignment != null) {
-          EvaluateAndLoadAssignment(instance.BestKnownAssignment);
-        } else {
-          BestKnownQuality = null;
-          BestKnownSolution = null;
-          BestKnownSolutions = null;
+    #region Problem Instance Loading
+    public void Load(QAPData data) {
+      Name = data.Name;
+      Description = data.Description;
+
+      var weights = new DoubleMatrix(data.Weights);
+      var distances = new DoubleMatrix(data.Distances);
+      var installationCosts = new DoubleMatrix(weights.Rows, distances.Columns); // all zero
+      var capacities = new DoubleArray(Enumerable.Range(0, distances.Rows).Select(x => 1.0).ToArray());
+      var demands = new DoubleArray(Enumerable.Range(0, weights.Rows).Select(x => 1.0).ToArray());
+
+      Load(demands, capacities, weights, distances, installationCosts, new DoubleValue(1));
+      EvaluateAndLoadAssignment(data.BestKnownAssignment);
+    }
+
+    public void Load(CTAPData data) {
+      Name = data.Name;
+      Description = data.Description;
+
+      var capacities = new DoubleArray(data.MemoryCapacities);
+      var demands = new DoubleArray(data.MemoryRequirements);
+      var weights = new DoubleMatrix(data.CommunicationCosts);
+      var installationCosts = new DoubleMatrix(data.ExecutionCosts.Transpose());
+      var distances = new DoubleMatrix(capacities.Length, capacities.Length);
+      for (int i = 0; i < capacities.Length - 1; i++)
+        for (int j = i + 1; j < capacities.Length; j++) {
+          distances[i, j] = 1;
         }
-      } catch {
-        return false;
-      }
-      return true;
-    }
-
-    public bool LoadFrom(CTAPInstance instance) {
-      try {
-        Name = instance.Name;
-        Description = instance.Description;
-
-        Capacities = new DoubleArray(instance.MemoryCapacities);
-        Demands = new DoubleArray(instance.MemoryRequirements);
-        Weights = new DoubleMatrix(instance.CommunicationCosts);
-        InstallationCosts = new DoubleMatrix(instance.ExecutionCosts.Transpose());
-        Distances = new DoubleMatrix(Capacities.Length, Capacities.Length);
-        for (int i = 0; i < Capacities.Length - 1; i++)
-          for (int j = i + 1; j < Capacities.Length; j++) {
-            Distances[i, j] = 1;
-          }
-
-        TransportationCosts.Value = 1;
-
-        if (instance.BestKnownAssignment != null) {
-          EvaluateAndLoadAssignment(instance.BestKnownAssignment);
-        } else {
-          BestKnownQuality = null;
-          BestKnownSolution = null;
-          BestKnownSolutions = null;
-        }
-      } catch {
-        return false;
-      }
-      return true;
-    }
-
-    public bool LoadFrom(TSPInstance instance) {
-      try {
-        if (instance.Dimension > 1000) return false;
-
-        Name = instance.Name;
-        Description = instance.Description;
-
-        Capacities = new DoubleArray(instance.Dimension);
-        Demands = new DoubleArray(instance.Dimension);
-        for (int i = 0; i < instance.Dimension; i++) {
-          Capacities[i] = 1;
-          Demands[i] = 1;
-        }
-        InstallationCosts = new DoubleMatrix(instance.Dimension, instance.Dimension);
-        Weights = new DoubleMatrix(instance.Dimension, instance.Dimension);
-        for (int i = 0; i < instance.Dimension; i++)
-          Weights[i, (i + 1) % instance.Dimension] = 1;
-        Distances = new DoubleMatrix(instance.GetDistanceMatrix());
-
-        TransportationCosts.Value = 1;
-
-        if (instance.BestKnownTour != null) {
-          EvaluateAndLoadAssignment(instance.BestKnownTour);
-        } else {
-          BestKnownQuality = null;
-          BestKnownSolution = null;
-          BestKnownSolutions = null;
-        }
-      } catch {
-        return false;
-      }
-      return true;
-    }
-
-    public bool LoadFrom(ATSPInstance instance) {
-      try {
-        Name = instance.Name;
-        Description = instance.Description;
-
-        Capacities = new DoubleArray(instance.Dimension);
-        Demands = new DoubleArray(instance.Dimension);
-        for (int i = 0; i < instance.Dimension; i++) {
-          Capacities[i] = 1;
-          Demands[i] = 1;
-        }
-        InstallationCosts = new DoubleMatrix(instance.Dimension, instance.Dimension);
-        Weights = new DoubleMatrix(instance.Dimension, instance.Dimension);
-        for (int i = 0; i < instance.Dimension; i++)
-          Weights[i, (i + 1) % instance.Dimension] = 1;
-        Distances = new DoubleMatrix(instance.Distances);
-
-        TransportationCosts.Value = 1;
-
-        if (instance.BestKnownTour != null) {
-          EvaluateAndLoadAssignment(instance.BestKnownTour);
-        } else {
-          BestKnownQuality = null;
-          BestKnownSolution = null;
-          BestKnownSolutions = null;
-        }
-      } catch {
-        return false;
-      }
-      return true;
-    }
-
-    public bool LoadFrom(GQAPInstance instance) {
-      try {
-        Name = instance.Name;
-        Description = instance.Description;
-
-        Capacities = new DoubleArray(instance.Capacities);
-        Demands = new DoubleArray(instance.Demands);
-        InstallationCosts = new DoubleMatrix(instance.InstallationCosts);
-        Weights = new DoubleMatrix(instance.Weights);
-        Distances = new DoubleMatrix(instance.Distances);
-        TransportationCosts.Value = instance.TransportationCosts;
-
-        if (instance.BestKnownAssignment != null) {
-          EvaluateAndLoadAssignment(instance.BestKnownAssignment);
-        } else if (instance.BestKnownQuality.HasValue) {
-          BestKnownQuality = new DoubleValue(instance.BestKnownQuality.Value);
-          BestKnownSolution = null;
-          BestKnownSolutions = null;
-        } else {
-          BestKnownQuality = null;
-          BestKnownSolution = null;
-          BestKnownSolutions = null;
-        }
-      } catch {
-        return false;
-      }
-      return true;
-    }
-    #endregion
+
+      Load(demands, capacities, weights, distances, installationCosts, new DoubleValue(1));
+      EvaluateAndLoadAssignment(data.BestKnownAssignment);
+    }
+
+    public void Load(TSPData data) {
+      if (data.Dimension > 1000)
+        throw new System.IO.InvalidDataException("Instances with more than 1000 cities are not supported.");
+
+      Name = data.Name;
+      Description = data.Description;
+
+      var capacities = new DoubleArray(data.Dimension);
+      var demands = new DoubleArray(data.Dimension);
+      for (int i = 0; i < data.Dimension; i++) {
+        capacities[i] = 1;
+        demands[i] = 1;
+      }
+      var installationCosts = new DoubleMatrix(data.Dimension, data.Dimension);
+      var weights = new DoubleMatrix(data.Dimension, data.Dimension);
+      for (int i = 0; i < data.Dimension; i++)
+        weights[i, (i + 1) % data.Dimension] = 1;
+      var distances = new DoubleMatrix(data.GetDistanceMatrix());
+
+      Load(demands, capacities, weights, distances, installationCosts, new DoubleValue(1));
+      EvaluateAndLoadAssignment(data.BestKnownTour);
+    }
+
+    public void Load(ATSPData data) {
+      Name = data.Name;
+      Description = data.Description;
+
+      var capacities = new DoubleArray(data.Dimension);
+      var demands = new DoubleArray(data.Dimension);
+      for (int i = 0; i < data.Dimension; i++) {
+        capacities[i] = 1;
+        demands[i] = 1;
+      }
+      var installationCosts = new DoubleMatrix(data.Dimension, data.Dimension);
+      var weights = new DoubleMatrix(data.Dimension, data.Dimension);
+      for (int i = 0; i < data.Dimension; i++)
+        weights[i, (i + 1) % data.Dimension] = 1;
+      var distances = new DoubleMatrix(data.Distances);
+
+      Load(demands, capacities, weights, distances, installationCosts, new DoubleValue(1));
+      EvaluateAndLoadAssignment(data.BestKnownTour);
+    }
+
+    public void Load(GQAPData data) {
+      Name = data.Name;
+      Description = data.Description;
+
+      var capacities = new DoubleArray(data.Capacities);
+      var demands = new DoubleArray(data.Demands);
+      var installationCosts = new DoubleMatrix(data.InstallationCosts);
+      var weights = new DoubleMatrix(data.Weights);
+      var distances = new DoubleMatrix(data.Distances);
+      var transportationCosts = new DoubleValue(data.TransportationCosts);
+
+      Load(demands, capacities, weights, distances, installationCosts, transportationCosts);
+      EvaluateAndLoadAssignment(data.BestKnownAssignment);
+
+      if (data.BestKnownAssignment == null && data.BestKnownQuality.HasValue) {
+        BestKnownQuality = new DoubleValue(data.BestKnownQuality.Value);
+      }
+    }
+
+    public void Load(DoubleArray demands, DoubleArray capacities,
+      DoubleMatrix weights, DoubleMatrix distances, DoubleMatrix installationCosts,
+      DoubleValue transportationCosts, DoubleValue overbookedCapacityPenalty = null) {
+      if (weights == null || weights.Rows == 0)
+        throw new System.IO.InvalidDataException(
+@"The given instance does not contain weights!");
+      if (weights.Rows != weights.Columns)
+        throw new System.IO.InvalidDataException(
+@"The weights matrix of the given instance contains an unequal number of rows
+and columns.");
+      Weights = weights;
+
+      if (distances == null || distances.Rows == 0)
+        throw new System.IO.InvalidDataException(
+@"The given instance does not contain distances!");
+      if (distances.Rows != distances.Columns)
+        throw new System.IO.InvalidDataException(
+@"The distances matrix of the given instance contains an unequal number of rows
+and columns.");
+      Distances = distances;
+
+      if (installationCosts == null || installationCosts.Rows == 0)
+        throw new System.IO.InvalidDataException(
+@"The given instance does not contain installation costs!");
+      if (installationCosts.Rows != weights.Rows
+        || installationCosts.Columns != distances.Columns)
+        throw new System.IO.InvalidDataException(
+@"The installation costs matrix of the given instance contains different number
+of rows than given in the weights matrix and a different number of columns than
+given in the distances matrix.");
+      InstallationCosts = installationCosts;
+
+      if (capacities == null || capacities.Length == 0)
+        throw new System.IO.InvalidDataException(
+@"The given instance does not contain capacities!");
+      if (capacities.Length != distances.Rows)
+        throw new System.IO.InvalidDataException(
+@"The given instance contains a different number of capacities than rows given in
+the distances matrix.");
+      Capacities = capacities;
+
+      if (demands == null || demands.Length == 0)
+        throw new System.IO.InvalidDataException(
+@"The given instance does not contain demands!");
+      if (demands.Length != weights.Rows)
+        throw new System.IO.InvalidDataException(
+@"The given instance contains a different number of demands than rows given in
+the weights matrix.");
+      Demands = demands;
+
+      if (transportationCosts == null)
+        throw new System.IO.InvalidDataException(
+@"The given instance does not contain transportation costs.");
+      TransportationCosts.Value = transportationCosts.Value;
+
+      if (overbookedCapacityPenalty != null)
+        OverbookedCapacityPenalty.Value = overbookedCapacityPenalty.Value;
+
+      BestKnownQuality = null;
+      BestKnownSolution = null;
+      BestKnownSolutions = null;
+    }
 
     private void EvaluateAndLoadAssignment(int[] vector) {
+      if (vector == null || vector.Length == 0) return;
       EvaluateAndLoadAssignment(new IntegerVector(vector));
     }
-    private void EvaluateAndLoadAssignment(IntegerVector assignment) {
+    public void EvaluateAndLoadAssignment(IntegerVector assignment) {
       if (!IsConfigurationValid()) {
         BestKnownQuality = null;
@@ -387,4 +393,5 @@
       BestKnownSolutions.Solutions.Add(new GQAPSolution((IntegerVector)assignment.Clone(), new DoubleValue(quality), new DoubleValue(flowDistanceQuality), new DoubleValue(installationQuality), new DoubleValue(overbookedCapacity)));
     }
+    #endregion
 
     #region Events
@@ -525,5 +532,5 @@
     #endregion
 
-    private bool IsConfigurationValid() {
+    public bool IsConfigurationValid() {
       return Weights != null && Distances != null && Demands != null && Capacities != null && InstallationCosts != null
         && Weights.Rows == Weights.Columns && Weights.Rows == InstallationCosts.Rows
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/CordeauGQAPDataDescriptor.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/CordeauGQAPDataDescriptor.cs	(revision 7548)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/CordeauGQAPDataDescriptor.cs	(revision 7548)
@@ -0,0 +1,35 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.CordeauGQAP {
+  internal class CordeauGQAPDataDescriptor : IDataDescriptor {
+    public string Name { get; internal set; }
+    public string Description { get; internal set; }
+
+    internal string InstanceIdentifier { get; set; }
+
+    internal CordeauGQAPDataDescriptor(string name, string description, string instanceIdentifier) {
+      this.Name = name;
+      this.Description = description;
+      this.InstanceIdentifier = instanceIdentifier;
+    }
+  }
+}
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/CordeauGQAPInstanceProvider.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/CordeauGQAPInstanceProvider.cs	(revision 7547)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/CordeauGQAPInstanceProvider.cs	(revision 7548)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.Problems.Instances.CordeauGQAP {
-  public class CordeauGQAPInstanceProvider : ProblemInstanceProvider<GQAPInstance> {
+  public class CordeauGQAPInstanceProvider : ProblemInstanceProvider<GQAPData> {
     public override string Name {
       get { return "Cordeau et al. GQAP instances"; }
@@ -49,14 +49,14 @@
     }
 
-    public override IEnumerable<IInstanceDescriptor> GetInstanceDescriptors() {
+    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
       return Assembly.GetExecutingAssembly()
           .GetManifestResourceNames()
           .Where(x => x.EndsWith(".txt"))
           .OrderBy(x => x)
-          .Select(x => new CordeauGQAPInstanceDescriptor(GetPrettyName(x), GetDescription(), x));
+          .Select(x => new CordeauGQAPDataDescriptor(GetPrettyName(x), GetDescription(), x));
     }
 
-    public override GQAPInstance LoadInstance(IInstanceDescriptor id) {
-      var descriptor = (CordeauGQAPInstanceDescriptor)id;
+    public override GQAPData LoadData(IDataDescriptor id) {
+      var descriptor = (CordeauGQAPDataDescriptor)id;
       using (var stream = Assembly.GetExecutingAssembly()
         .GetManifestResourceStream(descriptor.InstanceIdentifier)) {
@@ -72,5 +72,5 @@
     }
 
-    public override GQAPInstance LoadInstance(string path) {
+    public override GQAPData LoadData(string path) {
       var parser = new CordeauGQAPParser();
       parser.Parse(path);
@@ -83,10 +83,10 @@
     }
 
-    public override void SaveInstance(GQAPInstance instance, string path) {
+    public override void SaveData(GQAPData instance, string path) {
       throw new NotSupportedException();
     }
 
-    private GQAPInstance Load(CordeauGQAPParser parser) {
-      var instance = new GQAPInstance();
+    private GQAPData Load(CordeauGQAPParser parser) {
+      var instance = new GQAPData();
       instance.Equipments = parser.Equipments;
       instance.Locations = parser.Locations;
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/HeuristicLab.Problems.Instances.CordeauGQAP-3.3.csproj
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/HeuristicLab.Problems.Instances.CordeauGQAP-3.3.csproj	(revision 7547)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/HeuristicLab.Problems.Instances.CordeauGQAP-3.3.csproj	(revision 7548)
@@ -112,5 +112,5 @@
     <Compile Include="CordeauGQAPParser.cs" />
     <Compile Include="CordeauGQAPInstanceProvider.cs" />
-    <Compile Include="CordeauGQAPInstanceDescriptor.cs" />
+    <Compile Include="CordeauGQAPDataDescriptor.cs" />
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPDataDescriptor.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPDataDescriptor.cs	(revision 7548)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPDataDescriptor.cs	(revision 7548)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.ElloumiCTAP {
+  internal class ElloumiCTAPDataDescriptor : IDataDescriptor {
+    public string Name { get; internal set; }
+    public string Description { get; internal set; }
+
+    internal string InstanceIdentifier { get; set; }
+    internal string SolutionIdentifier { get; set; }
+
+    internal ElloumiCTAPDataDescriptor(string name, string description, string instanceIdentifier, string solutionIdentifier) {
+      this.Name = name;
+      this.Description = description;
+      this.InstanceIdentifier = instanceIdentifier;
+      this.SolutionIdentifier = solutionIdentifier;
+    }
+  }
+}
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPInstanceProvider.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPInstanceProvider.cs	(revision 7547)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPInstanceProvider.cs	(revision 7548)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.Problems.Instances.ElloumiCTAP {
-  public class ElloumiCTAPInstanceProvider : ProblemInstanceProvider<CTAPInstance> {
+  public class ElloumiCTAPInstanceProvider : ProblemInstanceProvider<CTAPData> {
     public override string Name {
       get { return "Elloumi's CTAP instances"; }
@@ -49,5 +49,5 @@
     }
 
-    public override IEnumerable<IInstanceDescriptor> GetInstanceDescriptors() {
+    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
       var solutions = Assembly.GetExecutingAssembly()
         .GetManifestResourceNames()
@@ -59,9 +59,9 @@
           .Where(x => x.EndsWith(".dat"))
           .OrderBy(x => x)
-          .Select(x => new ElloumiCTAPInstanceDescriptor(GetPrettyName(x), GetDescription(), x, solutions.ContainsKey(x) ? solutions[x] : String.Empty));
+          .Select(x => new ElloumiCTAPDataDescriptor(GetPrettyName(x), GetDescription(), x, solutions.ContainsKey(x) ? solutions[x] : String.Empty));
     }
 
-    public override CTAPInstance LoadInstance(IInstanceDescriptor id) {
-      var descriptor = (ElloumiCTAPInstanceDescriptor)id;
+    public override CTAPData LoadData(IDataDescriptor id) {
+      var descriptor = (ElloumiCTAPDataDescriptor)id;
       using (var stream = Assembly.GetExecutingAssembly()
         .GetManifestResourceStream(descriptor.InstanceIdentifier)) {
@@ -88,5 +88,5 @@
     }
 
-    public override CTAPInstance LoadInstance(string path) {
+    public override CTAPData LoadData(string path) {
       var parser = new ElloumiCTAPParser();
       parser.Parse(path);
@@ -97,10 +97,10 @@
     }
 
-    public override void SaveInstance(CTAPInstance instance, string path) {
+    public override void SaveData(CTAPData instance, string path) {
       throw new NotSupportedException();
     }
 
-    private CTAPInstance Load(ElloumiCTAPParser parser) {
-      var instance = new CTAPInstance();
+    private CTAPData Load(ElloumiCTAPParser parser) {
+      var instance = new CTAPData();
       instance.Processors = parser.Processors;
       instance.Tasks = parser.Tasks;
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/HeuristicLab.Problems.Instances.ElloumiCTAP-3.3.csproj
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/HeuristicLab.Problems.Instances.ElloumiCTAP-3.3.csproj	(revision 7547)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/HeuristicLab.Problems.Instances.ElloumiCTAP-3.3.csproj	(revision 7548)
@@ -133,5 +133,5 @@
     <EmbeddedResource Include="Data\tassc2005De.dat" />
     <None Include="Plugin.cs.frame" />
-    <Compile Include="ElloumiCTAPInstanceDescriptor.cs" />
+    <Compile Include="ElloumiCTAPDataDescriptor.cs" />
     <Compile Include="ElloumiCTAPInstanceProvider.cs" />
     <Compile Include="ElloumiCTAPParser.cs" />
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/HeuristicLab.Problems.Instances.QAPLIB-3.3.csproj
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/HeuristicLab.Problems.Instances.QAPLIB-3.3.csproj	(revision 7547)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/HeuristicLab.Problems.Instances.QAPLIB-3.3.csproj	(revision 7548)
@@ -51,5 +51,5 @@
   <ItemGroup>
     <Compile Include="QAPLIBParser.cs" />
-    <Compile Include="QAPLIBInstanceDescriptor.cs" />
+    <Compile Include="QAPLIBDataDescriptor.cs" />
     <Compile Include="QAPLIBSolutionParser.cs" />
     <Compile Include="QAPLIBInstanceProvider.cs" />
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBDataDescriptor.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBDataDescriptor.cs	(revision 7548)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBDataDescriptor.cs	(revision 7548)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.QAPLIB {
+  internal class QAPLIBDataDescriptor : IDataDescriptor {
+    public string Name { get; internal set; }
+    public string Description { get; internal set; }
+
+    internal string InstanceIdentifier { get; set; }
+    internal string SolutionIdentifier { get; set; }
+
+    internal QAPLIBDataDescriptor(string name, string description, string instanceIdentifier, string solutionIdentifier) {
+      this.Name = name;
+      this.Description = description;
+      this.InstanceIdentifier = instanceIdentifier;
+      this.SolutionIdentifier = solutionIdentifier;
+    }
+  }
+}
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBInstanceProvider.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBInstanceProvider.cs	(revision 7547)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBInstanceProvider.cs	(revision 7548)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.Problems.Instances.QAPLIB {
-  public class QAPLIBInstanceProvider : ProblemInstanceProvider<QAPInstance> {
+  public class QAPLIBInstanceProvider : ProblemInstanceProvider<QAPData> {
     public override string Name {
       get { return "QAPLIB"; }
@@ -49,5 +49,5 @@
     }
 
-    public override IEnumerable<IInstanceDescriptor> GetInstanceDescriptors() {
+    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
       var solutions = Assembly.GetExecutingAssembly()
         .GetManifestResourceNames()
@@ -59,9 +59,9 @@
           .Where(x => x.EndsWith(".dat"))
           .OrderBy(x => x)
-          .Select(x => new QAPLIBInstanceDescriptor(GetPrettyName(x), GetDescription(), x, solutions.ContainsKey(x) ? solutions[x] : String.Empty));
+          .Select(x => new QAPLIBDataDescriptor(GetPrettyName(x), GetDescription(), x, solutions.ContainsKey(x) ? solutions[x] : String.Empty));
     }
 
-    public override QAPInstance LoadInstance(IInstanceDescriptor id) {
-      var descriptor = (QAPLIBInstanceDescriptor)id;
+    public override QAPData LoadData(IDataDescriptor id) {
+      var descriptor = (QAPLIBDataDescriptor)id;
       using (var stream = Assembly.GetExecutingAssembly()
         .GetManifestResourceStream(descriptor.InstanceIdentifier)) {
@@ -87,5 +87,5 @@
     }
 
-    public override QAPInstance LoadInstance(string path) {
+    public override QAPData LoadData(string path) {
       var parser = new QAPLIBParser();
       parser.Parse(path);
@@ -96,10 +96,10 @@
     }
 
-    public override void SaveInstance(QAPInstance instance, string path) {
+    public override void SaveData(QAPData instance, string path) {
       throw new NotSupportedException();
     }
 
-    private QAPInstance Load(QAPLIBParser parser) {
-      var instance = new QAPInstance();
+    private QAPData Load(QAPLIBParser parser) {
+      var instance = new QAPData();
       instance.Dimension = parser.Size;
       instance.Distances = parser.Distances;
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/HeuristicLab.Problems.Instances.TSPLIB-3.3.csproj
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/HeuristicLab.Problems.Instances.TSPLIB-3.3.csproj	(revision 7547)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/HeuristicLab.Problems.Instances.TSPLIB-3.3.csproj	(revision 7548)
@@ -47,5 +47,5 @@
     <Compile Include="TSPLIBATSPInstanceProvider.cs" />
     <Compile Include="TSPLIBCVRPInstanceProvider.cs" />
-    <Compile Include="TSPLIBInstanceDescriptor.cs" />
+    <Compile Include="TSPLIBDataDescriptor.cs" />
     <Compile Include="TSPLIBTSPInstanceProvider.cs" />
     <Compile Include="TSPLIBParser.cs" />
